#include <string>
#include <vector>
#include <set>

namespace FontUtil {

	void EnumFonts(std::vector<std::pair<std::wstring, std::wstring>>& fonts); // <internal, display>
	std::wstring GetApplicationFont();
	
	enum GlyphDataType {
		kGlyphMove,
		kGlyphLine,
		kGlyphCurve,
		kGlyphClose,
	};
	
	struct GlyphPoint {
		float x, y;
		GlyphPoint() { }
		GlyphPoint(float _x, float _y) : x(_x), y(_y) { }
	};
	
	struct GlyphData {
		GlyphDataType type;
		GlyphPoint point[3];
	};
	
	float GetFontGlyph(const std::wstring& str, const std::wstring& fontname, std::vector<GlyphData>& data);
	
}

